/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// 			VBXSTD12.H
//			COPYRIGHT Denis CHEVRON, 1993, 1994, All rights reserved
//			Classes and defines for VBX Studio 1.2 VBXs.
//
//			You can use this file as you want.
//
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
//			Defines can be used instead of values.
//			Following classes provide an easy way to read and write VBX properties with VC++:
//			For instance, you can use:
//
//			CVBEdit* VBEdit1;
//			DWORD a;
//			VBEdit1->Increment() = TRUE;
//			VBEdit1->MinRange() = VBEdit1->MaxRange();
//			a = VBEdit1->GetSel();
//
//			instead of:
//
//			CVBControl* VBEdit1;
//			VBEdit1->SetNumProperty( "Increment", TRUE );
//			VBEdit1->SetFloatProperty( "MinRange", VBEdit1->GetFloatProperty("MaxRange") );
//			...
//
//			You can use properties class ( CInt, CLong... ) as you do with int or long, but don' t misunderstood,
//			following classes use methods ( with () ), not variables ( without () ), like VB do.
//
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
//			Also, you can integrate these classes into VC++ AppStudio thanks to VBX ( to allow you to create
//			an instance for these classes into AppStudio ): To do this, you must manually add some DDX in your
//			APSTUDIO.INI file, see DDX.TXT to do it.
//
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
//			Regarding VBX events management, there are some functions to make it easier:
//
//			EventClickID( LPPARAM lp ) --> returns the ID
//			EventClickString( LPPARAM lp ) --> returns the String ...

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#ifndef _ASVBDO12_H
#include <asvbdo12.h>
#endif

#define _VBXSTD12_H

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//	PART 1 - Defines for most used properties
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
				
				
				// ---------------------------------------------------
				//	Color40: Used for colors lists ( BackColor.. )
				// ---------------------------------------------------
				#define COLOR40_SYSTEM				0
				#define COLOR40_WHITE		 		 1
				#define COLOR40_BLACK		 		 2
				#define COLOR40_GREY100				3
				#define COLOR40_LIGHTGREY		 4
				#define COLOR40_GREY150				5
				#define COLOR40_DARKGREY		 6
				#define COLOR40_CYAN25				7
				#define COLOR40_CYAN50				8
				#define COLOR40_CYAN100				9
				#define COLOR40_LIGHTCYAN		10
				#define COLOR40_DARKCYAN		11
				#define COLOR40_CYAN200			   12
				#define COLOR40_BLUE50				13
				#define COLOR40_BLUEGREEN		14
				#define COLOR40_BLUE150				15
				#define COLOR40_LIGHTBLUE		 16
				#define COLOR40_BLUE200				17
				#define COLOR40_DARKBLUE		 18
				#define COLOR40_BLUE250				19
				#define COLOR40_GREEN25			   20
				#define COLOR40_GREEN50				21
				#define COLOR40_GREEN100		  22
				#define COLOR40_LIGHTGREEN	 	23
				#define COLOR40_GREEN200	      24
				#define COLOR40_GREEN250	  	  25
				#define COLOR40_DRAKGREEN	   26
				#define COLOR40_KHAKI			 	 27
				#define COLOR40_YELLOW50		28
				#define COLOR40_YELLOW100		29
				#define COLOR40_LIGHTYELLOW	 30
				#define COLOR40_YELLOW150	 	31
				#define COLOR40_ORANGE			  32
				#define COLOR40_BEIGE			     33
				#define COLOR40_DARKYELLOW	 34
				#define COLOR40_BROWN			  35
				#define COLOR40_PINK100				36
				#define COLOR40_RED100			    37
				#define COLOR40_LIGHTRED		 38
				#define COLOR40_DARKRED			 39
				#define COLOR40_FUSHIA50		  40
				#define COLOR40_FUSHIA100		  41
				#define COLOR40_LIGHTFUSHIA	   42
				#define COLOR40_DARKFUSHIA	   43
				
				// ---------------------------------------------------
				//	RGB Colors ( when a CLong
				//	property is defined for a color value )
				// ---------------------------------------------------         
				#define RGB_WHITE				RGB(255,255,255)
				#define RGB_BLACK				RGB(0,0,0)
				#define RGB_DARKGREY        RGB(128,128,128)
				#define RGB_LIGHTGREY		RGB( 192,192,192)
				#define RGB_LIGHTRED		  RGB(255,0,0)
				#define RGB_DARKRED			 RGB(128,0,0)
				#define RGB_LIGHTGREEN	   RGB(0,255,0)
				#define RGB_DARKGREEN	   RGB(0,128,0)
				#define RGB_LIGHTBLUE		RGB(0,0,255)
				#define RGB_DARKBLUE		RGB(0,0,128)
				#define RGB_YELLOW			  RGB(255,255,0)
				#define RGB_BROWN			  RGB(128,128,0)
				#define RGB_LIGHTCYAN		RGB(0,255,255)                                                 
				#define RGB_DARKCYAN		RGB(0,128,128)                                                 
				#define RGB_LIGHTFUSHIA		RGB(255,0,255)                                                 
				#define RGB_DARKFUSHIA		RGB(128,0,128)                                                 

				
                // ---------------------------------------------------
				//	TextAlignment
				// ---------------------------------------------------
				#define TEXT_CENTRE		0
				#define TEXT_RIGHT		  1
				#define TEXT_LEFT		   2

                // ---------------------------------------------------
				//	List and Combo, DataType
				// ---------------------------------------------------
                #define DATA_TEXT			0
                #define DATA_PICTURE	 1
                #define DATA_BOTH		   2

                // ---------------------------------------------------
				//	VBFCombo, VBFList DataType
				// ---------------------------------------------------
				#define FCOMBO_FILES				0
                #define FCOMBO_DRIVES			  1
                #define FCOMBO_USER				   2
                #define FLIST_FILES						0
                #define FLIST_DIRS			  			 1
                #define FLIST_USER				   		2


                // ---------------------------------------------------
				//	VBFCombo, FilesDisplay
				// ---------------------------------------------------
	           	#define DISPLAY_QUICK				0
                #define DISPLAY_WINFILE			   1
                #define DISPLAY_FULL				 2
				
                // ---------------------------------------------------
				//	VBLine, LineStyle
				// ---------------------------------------------------
				#define LINE_TOP					0
				#define LINE_BOTTOM				1
				#define LINE_LEFT					2
				#define LINE_RIGHT					3
				#define LINE_TABRECT			4
				#define LINE_TABLEFT			 5
				#define LINE_TABBOTTOM		 6
				#define LINE_TABRIGHT			7
				                                                 
                // ---------------------------------------------------
				//	VBLine, 3DStyle
				// ---------------------------------------------------
				#define LINE3D_NONE				   0
				#define LINE3D_INSMALL			1
				#define LINE3D_INLARGE			 2
				#define LINE3D_OUTSMALL		  3
				#define LINE3D_OUTLARGE		   4
				
				// ---------------------------------------------------
				//	VBText, Vertical and Hor. positions
				// ---------------------------------------------------
				#define VPOS_CENTRE		0 /* VPOS... aren' t available with multiline VBText */
				#define VPOS_TOP		   1
				#define VPOS_BOTTOM	   2
				#define HPOS_CENTRE		0 
				#define HPOS_RIGHT		  1
				#define HPOS_LEFT    	   2

				// ---------------------------------------------------
				//	VBText, 3DStyle ( text )
				// ---------------------------------------------------
				#define _3DTEXT_NONE		0
				#define _3DTEXT_OUT		 1
				#define _3DTEXT_IN		    2

				// ---------------------------------------------------
				//	VBText, 3D Border 
				// ---------------------------------------------------
				#define _3DBORDER_NONE		 0
				#define _3DBORDER_INSET	     1
				#define _3DBORDER_RAISED		2


				// ---------------------------------------------------
				//	VBEdit, DataType
				// ---------------------------------------------------
				#define INPUT_NOCHECK								0
				#define INPUT_ALPHANUM        	   				  1
				#define INPUT_ALPHA									  2
				#define INPUT_NUM						  				3
				#define INPUT_SIGNEDINT			  					4
				#define INPUT_UNSIGNEDINT						 5
				#define INPUT_SIGNEDLONG						 6
				#define INPUT_UNSIGNEDLONG		 			  7
				#define INPUT_FLOAT					 				   8
				#define INPUT_TIME										9
				#define INPUT_DATEUS					   			10  /* MM\DD\YY */	
				#define INPUT_DATEFRENCH			  			11
				#define INPUT_DATEUSLONG			  		    12 /* MM\DD\YYYY */	
				#define INPUT_DATEFRENCHLONG	 		   13
				#define INPUT_DRIVE						 			   14
				#define INPUT_FILENAME					  			15
				#define INPUT_FILENAMEANDDIR				 16
				#define INPUT_FILENAMEANDDIREXIST		 17
				#define INPUT_ALLEXIST								18			
				#define INPUT_DIRWITHSLASH					   19
				#define INPUT_DIRWITHSLASHEXIST		  	   20
				#define INPUT_DIRWITHOUTSLASH			    21
				#define INPUT_DIRWITHOUTSLASHEXIST		22
				#define INPUT_DIRNOCHECK						  23 // with or without slash
				#define INPUT_DIRNOCHECKEXIST				 24
				
				
				
				
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//	PART 2 - Object interface
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
			
			/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
			//	CVBSpin class for the VBSpin VBX
			//	
			class CVBSpin : public CStatic
				{
				public:
				CVBControl* GetVBX() { return (CVBControl*)this; };
				CHsz CtlName() { return CHsz((CVBControl*)this, 0); }
				CLong Left() { return CLong((CVBControl*)this, 2); }
				CLong Top() { return CLong((CVBControl*)this, 3); }
				CLong Width() { return CLong((CVBControl*)this, 4); }
				CLong Height() { return CLong((CVBControl*)this, 5); }
				CBool Visible() { return CBool((CVBControl*)this, 6); }
				CHsz Tag() { return CHsz((CVBControl*)this, 10); }
				CBool TabStop() { return CBool((CVBControl*)this, 14); }
				CBool Enabled() { return CBool((CVBControl*)this, 12); }
				CInt AssociatedID() { return CInt((CVBControl*)this, 15); } // special
				CLong ArrowsColor() { return CLong((CVBControl*)this, 16); }
				CLong BorderColor() { return CLong((CVBControl*)this, 17); }
				CFloat Minimum() { return CFloat((CVBControl*)this, 18); }
				CFloat Maximum() { return CFloat((CVBControl*)this, 19); }
				CFloat Value() { return CFloat((CVBControl*)this, 20); }
				CBool HandCursor() { return CBool((CVBControl*)this, 21); }
				CBool AutoPos() { return CBool((CVBControl*)this, 22); }
				CBool UseSystemColors() { return CBool((CVBControl*)this, 26); }
				CInt AssociatedHwnd() { return CInt((CVBControl*)this, 27); } // special
				// Events support 
				short EventKeyCode( LPVOID lp ) { return (short)AFX_NUM_EVENTPARAMINDEX( short, lp, 1); } // KeyUp, KeyDown
				short EventKeyShift( LPVOID lp ) { return (short)AFX_NUM_EVENTPARAMINDEX( short, lp, 0); } // KeyUp, KeyDown
				short EventKeyPress( LPVOID lp ) { return (short)AFX_NUM_EVENTPARAM( short, lp ); } // KeyPress
				short EventMouseBtn( LPVOID lp ) { return (short)AFX_NUM_EVENTPARAMINDEX( short, lp, 3); } // MouseUp, MouseDown
				short EventMouseShift( LPVOID lp ) { return (short)AFX_NUM_EVENTPARAMINDEX( short, lp, 2); } // MouseUp, MouseDown
				short EventMouseX( LPVOID lp ) { return (short)AFX_NUM_EVENTPARAMINDEX( short, lp, 1); } // MouseUp, MouseDown
				short EventMouseY( LPVOID lp ) { return (short)AFX_NUM_EVENTPARAMINDEX( short, lp, 0); } // MouseUp, MouseDown
				};	
			        
            

			/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
			//	CVBEdit class for the VBEdit VBX
			//	
			class CVBEdit : public CEdit
				{
				public:
				CVBControl* GetVBX() { return (CVBControl*)this; };
				CHsz CtlName() { return CHsz((CVBControl*)this, 0); }
				CLong Left() { return CLong((CVBControl*)this, 2); }
				CLong Top() { return CLong((CVBControl*)this, 3); }
				CLong Width() { return CLong((CVBControl*)this, 4); }
				CLong Height() { return CLong((CVBControl*)this, 5); }
				CBool Visible() { return CBool((CVBControl*)this, 6); }
				CHsz Tag() { return CHsz((CVBControl*)this, 10); }
				CHsz FontName() { return CHsz((CVBControl*)this, 11); }
				CBool FontBold() { return CBool((CVBControl*)this, 12); }
				CFloat FontSize() { return CFloat((CVBControl*)this, 13); }
				CLong ForeColor() { return CLong((CVBControl*)this, 14); }
				CBool TabStop() { return CBool((CVBControl*)this, 16); }
				CBool Enabled() { return CBool((CVBControl*)this, 17); }
				CInt BorderStyle() { return CInt((CVBControl*)this, 19); }
				CLong BackColor() { return CLong((CVBControl*)this, 20); }
				CBool Border3D() { return CBool((CVBControl*)this, 21); }
				CInt Case() { return CInt((CVBControl*)this, 25); }
				CBool NoHideSelection() { return CBool((CVBControl*)this, 26); }
				CBool OEMConvert() { return CBool((CVBControl*)this, 27); }
				CBool PasswordChars() { return CBool((CVBControl*)this, 28); }
				CBool ReadOnly() { return CBool((CVBControl*)this, 29); }
				CInt DataType() { return CInt((CVBControl*)this, 30); }
				CInt MaxLength() { return CInt((CVBControl*)this, 31); }
				CFloat MaxRange() { return CFloat((CVBControl*)this, 32); }
				CFloat MinRange() { return CFloat((CVBControl*)this, 33); }
				CBool BeepIfError() { return CBool((CVBControl*)this, 34); }
				CBool AllowAutoChange() { return CBool((CVBControl*)this, 35); }
				CInt SetSel() { return CInt((CVBControl*)this, 36); } // special, we use CEdit::SetSel instead
				CBool IsValid() { return CBool((CVBControl*)this, 37); } // special
				CInt IncrementValue() { return CInt((CVBControl*)this, 38); }
				CBool Increment() { return CBool((CVBControl*)this, 39); } // special
				CBool Decrement() { return CBool((CVBControl*)this, 40); } // special
				CHsz Text() { return CHsz((CVBControl*)this, 41); }
				CBool UseSystemColors() { return CBool((CVBControl*)this, 42); }
				CBool AllowBlankField() { return CBool((CVBControl*)this, 43); }
				};

            
            
			/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
			//	CVBList class for the VBList VBX
			//	
			class CVBList : public CListBox
				{
				public:
				CVBControl* GetVBX() { return (CVBControl*)this; };
				CHsz CtlName() { return CHsz((CVBControl*)this, 0); }
				CLong Left() { return CLong((CVBControl*)this, 2); }
				CLong Top() { return CLong((CVBControl*)this, 3); }
				CLong Width() { return CLong((CVBControl*)this, 4); }
				CLong Height() { return CLong((CVBControl*)this, 5); }
				CBool Visible() { return CBool((CVBControl*)this, 6); }
				CHsz Tag() { return CHsz((CVBControl*)this, 10); }
				CInt ItemHeight() { return CInt((CVBControl*)this, 11); }
				CBool UseHorzScrollBar() { return CBool((CVBControl*)this, 12); }
				CInt DataType() { return CInt((CVBControl*)this, 13); }
				CInt DisplayMode() { return CInt((CVBControl*)this, 14); }
				CInt PictureWidth() { return CInt((CVBControl*)this, 15); }
				CInt PictureHeight() { return CInt((CVBControl*)this, 16); }
				CInt PictureXMargin() { return CInt((CVBControl*)this, 17); }
				CInt PictureYMargin() { return CInt((CVBControl*)this, 18); }
				CInt TextXMargin() { return CInt((CVBControl*)this, 19); }
				CInt TextYMargin() { return CInt((CVBControl*)this, 20); }
				CBool Sort() { return CBool((CVBControl*)this, 21); }
				CBool MultipleSel() { return CBool((CVBControl*)this, 22); }
				CBool DisableNoScroll() { return CBool((CVBControl*)this, 23); }
				CBool NoRedraw() { return CBool((CVBControl*)this, 24); }
				CInt BackColor() { return CInt((CVBControl*)this, 25); }
				CInt Text3D() { return CInt((CVBControl*)this, 26); }
				CInt TextAlignment() { return CInt((CVBControl*)this, 27); }
				CHsz Caption() { return CHsz((CVBControl*)this, 28); }
				CHsz FontName() { return CHsz((CVBControl*)this, 29); }
				CBool FontBold() { return CBool((CVBControl*)this, 30); }
				CFloat FontSize() { return CFloat((CVBControl*)this, 31); }
				CLong ForeColor() { return CLong((CVBControl*)this, 32); }
				CBool TabStop() { return CBool((CVBControl*)this, 34); }
				CBool Enabled() { return CBool((CVBControl*)this, 35); }
				CInt MousePointer() { return CInt((CVBControl*)this, 36); }
				CPicture Bitmap01() { return CPicture((CVBControl*)this, 38); }
				CPicture Bitmap02() { return CPicture((CVBControl*)this, 39); }
				CPicture Bitmap03() { return CPicture((CVBControl*)this, 40); }
				CPicture Bitmap04() { return CPicture((CVBControl*)this, 41); }
				CPicture Bitmap05() { return CPicture((CVBControl*)this, 42); }
				CPicture Bitmap06() { return CPicture((CVBControl*)this, 43); }
				CPicture Bitmap07() { return CPicture((CVBControl*)this, 44); }
				CPicture Bitmap08() { return CPicture((CVBControl*)this, 45); }
				CPicture Bitmap09() { return CPicture((CVBControl*)this, 46); }
				CPicture Bitmap10() { return CPicture((CVBControl*)this, 47); }
				CPicture Bitmap11() { return CPicture((CVBControl*)this, 48); }
				CPicture Bitmap12() { return CPicture((CVBControl*)this, 49); }
				CPicture Bitmap13() { return CPicture((CVBControl*)this, 50); }
				CPicture Bitmap14() { return CPicture((CVBControl*)this, 51); }
				CPicture Bitmap15() { return CPicture((CVBControl*)this, 52); }
				CPicture Bitmap16() { return CPicture((CVBControl*)this, 53); }
				CPicture Bitmap17() { return CPicture((CVBControl*)this, 54); }
				CPicture Bitmap18() { return CPicture((CVBControl*)this, 55); }
				CPicture Bitmap19() { return CPicture((CVBControl*)this, 56); }
				CPicture Bitmap20() { return CPicture((CVBControl*)this, 57); }
				CPicture Bitmap21() { return CPicture((CVBControl*)this, 58); }
				CPicture Bitmap22() { return CPicture((CVBControl*)this, 59); }
				CPicture Bitmap23() { return CPicture((CVBControl*)this, 60); }
				CPicture Bitmap24() { return CPicture((CVBControl*)this, 61); }
				CPicture Bitmap25() { return CPicture((CVBControl*)this, 62); }
				CPicture Bitmap26() { return CPicture((CVBControl*)this, 63); }
				CPicture Bitmap27() { return CPicture((CVBControl*)this, 64); }
				CPicture Bitmap28() { return CPicture((CVBControl*)this, 65); }
				CPicture Bitmap29() { return CPicture((CVBControl*)this, 66); }
				CPicture Bitmap30() { return CPicture((CVBControl*)this, 67); }
				CBool UseTranspBitmap() { return CBool((CVBControl*)this, 68); }
				CBool AlwaysBitmapped() { return CBool((CVBControl*)this, 69); }
				CBool ModeTest() { return CBool((CVBControl*)this, 70); }
				CBool Border3D() { return CBool((CVBControl*)this, 72); }
				CBool ParentNotify() { return CBool((CVBControl*)this, 75); }
				CInt ListCount() { return CInt((CVBControl*)this, 76); } // special
				BOOL ListIndex( int index = 0) { return (BOOL)((CVBControl*)this)->GetNumProperty( 77, index ); } // special
				CString ListString( int index = 0) { return (CString)((CVBControl*)this)->GetStrProperty( 78, index ); } // special
				CBool SetRedraw() { return CBool((CVBControl*)this, 79); } // we use CWnd::SetRedraw instead
				CLong SetSel() { return CLong((CVBControl*)this, 80); } // special, we use CListBox::SetSel instead
				// Events support
				short EventDblClkID( LPVOID lp ) { return (short)AFX_NUM_EVENTPARAM( short, lp); }
				short EventSelChangeID( LPVOID lp ) { return (short)AFX_NUM_EVENTPARAM( short, lp); }
				short EventKeyCode( LPVOID lp ) { return (short)AFX_NUM_EVENTPARAMINDEX( short, lp, 1); } // KeyUp, KeyDown
				short EventKeyShift( LPVOID lp ) { return (short)AFX_NUM_EVENTPARAMINDEX( short, lp, 0); } // KeyUp, KeyDown
				short EventKeyPress( LPVOID lp ) { return (short)AFX_NUM_EVENTPARAM( short, lp ); } // KeyPress
				short EventMouseBtn( LPVOID lp ) { return (short)AFX_NUM_EVENTPARAMINDEX( short, lp, 3); } // MouseUp, MouseDown
				short EventMouseShift( LPVOID lp ) { return (short)AFX_NUM_EVENTPARAMINDEX( short, lp, 2); } // MouseUp, MouseDown
				short EventMouseX( LPVOID lp ) { return (short)AFX_NUM_EVENTPARAMINDEX( short, lp, 1); } // MouseUp, MouseDown
				short EventMouseY( LPVOID lp ) { return (short)AFX_NUM_EVENTPARAMINDEX( short, lp, 0); } // MouseUp, MouseDown
				};
						        
			        
			/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
			//	CVBFList class for the VBFList VBX
			//	
			class CVBFList : public CListBox
				{
				public:
				CVBControl* GetVBX() { return (CVBControl*)this; };
				CHsz CtlName() { return CHsz((CVBControl*)this, 0); }
				CLong Left() { return CLong((CVBControl*)this, 2); }
				CLong Top() { return CLong((CVBControl*)this, 3); }
				CLong Width() { return CLong((CVBControl*)this, 4); }
				CLong Height() { return CLong((CVBControl*)this, 5); }
				CBool Visible() { return CBool((CVBControl*)this, 6); }
				CHsz Tag() { return CHsz((CVBControl*)this, 10); }
				CHsz FontName() { return CHsz((CVBControl*)this, 11); }
				CBool FontBold() { return CBool((CVBControl*)this, 12); }
				CFloat FontSize() { return CFloat((CVBControl*)this, 13); }
				CLong ForeColor() { return CLong((CVBControl*)this, 14); }
				CBool TabStop() { return CBool((CVBControl*)this, 16); }
				CBool Enabled() { return CBool((CVBControl*)this, 17); }
				CInt ItemHeight() { return CInt((CVBControl*)this, 19); }
				CInt DataType() { return CInt((CVBControl*)this, 20); }
				CBool MultipleSel() { return CBool((CVBControl*)this, 21); }
				CBool DisableNoScroll() { return CBool((CVBControl*)this, 22); }
				CInt BackColor() { return CInt((CVBControl*)this, 23); }
				CInt Text3D() { return CInt((CVBControl*)this, 24); }
				CBool UseHorizScrollBar() { return CBool((CVBControl*)this, 25); }
				CHsz InValue() { return CHsz((CVBControl*)this, 26); } 
				CHsz OutValue() { return CHsz((CVBControl*)this, 27); } // special
				CInt StaticID() { return CInt((CVBControl*)this, 28); } // special
				CInt ListCount() { return CInt((CVBControl*)this, 29); } // special
				BOOL ListIndex( int index = 0) { return (BOOL)((CVBControl*)this)->GetNumProperty( 30, index ); } // special
				CString ListString( int index = 0) { return (CString)((CVBControl*)this)->GetStrProperty( 31, index ); } // special
				CBool Border3D() { return CBool((CVBControl*)this, 32); }
				CBool Sort() { return CBool((CVBControl*)this, 36); }
				CBool ParentNotify() { return CBool((CVBControl*)this, 37); }
				CInt FilesDisplay() { return CInt((CVBControl*)this, 38); }
				CBool SetRedraw() { return CBool((CVBControl*)this, 39); }
				CLong SetSel() { return CLong((CVBControl*)this, 40); } // special, use CListBox::SetSel instead
				CInt StaticHwnd() { return CInt((CVBControl*)this, 41); } // special
				// Events support ( same as VBList )
				short EventDblClkID( LPVOID lp ) { return (short)AFX_NUM_EVENTPARAM( short, lp); }
				short EventSelChangeID( LPVOID lp ) { return (short)AFX_NUM_EVENTPARAM( short, lp); }
				short EventKeyCode( LPVOID lp ) { return (short)AFX_NUM_EVENTPARAMINDEX( short, lp, 1); } // KeyUp, KeyDown
				short EventKeyShift( LPVOID lp ) { return (short)AFX_NUM_EVENTPARAMINDEX( short, lp, 0); } // KeyUp, KeyDown
				short EventKeyPress( LPVOID lp ) { return (short)AFX_NUM_EVENTPARAM( short, lp ); } // KeyPress
				short EventMouseBtn( LPVOID lp ) { return (short)AFX_NUM_EVENTPARAMINDEX( short, lp, 3); } // MouseUp, MouseDown
				short EventMouseShift( LPVOID lp ) { return (short)AFX_NUM_EVENTPARAMINDEX( short, lp, 2); } // MouseUp, MouseDown
				short EventMouseX( LPVOID lp ) { return (short)AFX_NUM_EVENTPARAMINDEX( short, lp, 1); } // MouseUp, MouseDown
				short EventMouseY( LPVOID lp ) { return (short)AFX_NUM_EVENTPARAMINDEX( short, lp, 0); } // MouseUp, MouseDown
				};
				
				
				
			
			/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
			//	CVBCombo class for the VBCombo VBX
			//	
			class CVBCombo : public CComboBox
				{
				public:
				CVBControl* GetVBX() { return (CVBControl*)this; };
				CHsz CtlName() { return CHsz((CVBControl*)this, 0); }
				CLong Left() { return CLong((CVBControl*)this, 2); }
				CLong Top() { return CLong((CVBControl*)this, 3); }
				CLong Width() { return CLong((CVBControl*)this, 4); }
				CLong Height() { return CLong((CVBControl*)this, 5); }
				CBool Visible() { return CBool((CVBControl*)this, 6); }
				CHsz Tag() { return CHsz((CVBControl*)this, 10); }
				CHsz Caption() { return CHsz((CVBControl*)this, 11); }
				CHsz FontName() { return CHsz((CVBControl*)this, 12); }
				CBool FontBold() { return CBool((CVBControl*)this, 13); }
				CFloat FontSize() { return CFloat((CVBControl*)this, 14); }
				CLong ForeColor() { return CLong((CVBControl*)this, 15); }
				CBool TabStop() { return CBool((CVBControl*)this, 17); }
				CBool Enabled() { return CBool((CVBControl*)this, 18); }
				CInt ListCount() { return CInt((CVBControl*)this, 20); }
				BOOL ListIndex( int index = 0) { return (BOOL)((CVBControl*)this)->GetNumProperty( 21, index ); } // special
				CString ListString( int index = 0) { return (CString)((CVBControl*)this)->GetStrProperty( 22, index ); } // special
				CBool Border3D() { return CBool((CVBControl*)this, 23); }
				CLong SetSel() { return CLong((CVBControl*)this, 27); } // special
				CInt ItemHeight() { return CInt((CVBControl*)this, 28); }
				CInt ListHeight() { return CInt((CVBControl*)this, 29); }
				CInt StaticHeight() { return CInt((CVBControl*)this, 30); }
				CLong InitialValue() { return CLong((CVBControl*)this, 31); }
				CInt BitmapWidth() { return CInt((CVBControl*)this, 32); }
				CHsz OutValue() { return CHsz((CVBControl*)this, 33); } // special
				CInt BitmapHeight() { return CInt((CVBControl*)this, 34); }
				CInt XMarginBitmap() { return CInt((CVBControl*)this, 35); }
				CInt YMarginBitmap() { return CInt((CVBControl*)this, 36); }
				CInt XMarginText() { return CInt((CVBControl*)this, 37); }
				CInt YMarginText() { return CInt((CVBControl*)this, 38); }
				CInt DataType() { return CInt((CVBControl*)this, 39); }
				CInt DisplayMode() { return CInt((CVBControl*)this, 40); }
				CBool UseTranspBitmap() { return CBool((CVBControl*)this, 41); }
				CBool AlwaysBitmapped() { return CBool((CVBControl*)this, 42); }
				CBool TestMode() { return CBool((CVBControl*)this, 43); }
				CBool AutoSearchInList() { return CBool((CVBControl*)this, 44); }
				CInt BackColor() { return CInt((CVBControl*)this, 45); }
				CInt Text3D() { return CInt((CVBControl*)this, 46); }
				CInt TextAlignment() { return CInt((CVBControl*)this, 47); }
				CPicture Bitmap01() { return CPicture((CVBControl*)this, 48); }
				CPicture Bitmap02() { return CPicture((CVBControl*)this, 49); }
				CPicture Bitmap03() { return CPicture((CVBControl*)this, 50); }
				CPicture Bitmap04() { return CPicture((CVBControl*)this, 51); }
				CPicture Bitmap05() { return CPicture((CVBControl*)this, 52); }
				CPicture Bitmap06() { return CPicture((CVBControl*)this, 53); }
				CPicture Bitmap07() { return CPicture((CVBControl*)this, 54); }
				CPicture Bitmap08() { return CPicture((CVBControl*)this, 55); }
				CPicture Bitmap09() { return CPicture((CVBControl*)this, 56); }
				CPicture Bitmap10() { return CPicture((CVBControl*)this, 57); }
				CPicture Bitmap11() { return CPicture((CVBControl*)this, 58); }
				CPicture Bitmap12() { return CPicture((CVBControl*)this, 59); }
				CPicture Bitmap13() { return CPicture((CVBControl*)this, 60); }
				CPicture Bitmap14() { return CPicture((CVBControl*)this, 61); }
				CPicture Bitmap15() { return CPicture((CVBControl*)this, 62); }
				CPicture Bitmap16() { return CPicture((CVBControl*)this, 63); }
				CPicture Bitmap17() { return CPicture((CVBControl*)this, 64); }
				CPicture Bitmap18() { return CPicture((CVBControl*)this, 65); }
				CPicture Bitmap19() { return CPicture((CVBControl*)this, 66); }
				CPicture Bitmap20() { return CPicture((CVBControl*)this, 67); }
				CPicture Bitmap21() { return CPicture((CVBControl*)this, 68); }
				CPicture Bitmap22() { return CPicture((CVBControl*)this, 69); }
				CPicture Bitmap23() { return CPicture((CVBControl*)this, 70); }
				CPicture Bitmap24() { return CPicture((CVBControl*)this, 71); }
				CPicture Bitmap25() { return CPicture((CVBControl*)this, 72); }
				CPicture Bitmap26() { return CPicture((CVBControl*)this, 73); }
				CPicture Bitmap27() { return CPicture((CVBControl*)this, 74); }
				CPicture Bitmap28() { return CPicture((CVBControl*)this, 75); }
				CPicture Bitmap29() { return CPicture((CVBControl*)this, 76); }
				CPicture Bitmap30() { return CPicture((CVBControl*)this, 77); }
				// Events support 
				short EventClickID( LPVOID lp ) { return (short)AFX_NUM_EVENTPARAMINDEX( short, lp, 0); } 
				LPCSTR EventClickString( LPVOID lp ) { return (LPCSTR)AFX_HLSTR_EVENTPARAMINDEX(  lp, 1); } 
				short EventSelChangeID( LPVOID lp ) { return (short)AFX_NUM_EVENTPARAMINDEX( short, lp, 0); } 
				LPCSTR EventSelChangeString( LPVOID lp ) { return (LPCSTR)AFX_HLSTR_EVENTPARAMINDEX( lp, 1); } 
				short EventKeyCode( LPVOID lp ) { return (short)AFX_NUM_EVENTPARAMINDEX( short, lp, 1); } // KeyUp, KeyDown
				short EventKeyShift( LPVOID lp ) { return (short)AFX_NUM_EVENTPARAMINDEX( short, lp, 0); } // KeyUp, KeyDown
				short EventKeyPress( LPVOID lp ) { return (short)AFX_NUM_EVENTPARAM( short, lp ); } // KeyPress
				short EventMouseBtn( LPVOID lp ) { return (short)AFX_NUM_EVENTPARAMINDEX( short, lp, 3); } // MouseUp, MouseDown
				short EventMouseShift( LPVOID lp ) { return (short)AFX_NUM_EVENTPARAMINDEX( short, lp, 2); } // MouseUp, MouseDown
				short EventMouseX( LPVOID lp ) { return (short)AFX_NUM_EVENTPARAMINDEX( short, lp, 1); } // MouseUp, MouseDown
				short EventMouseY( LPVOID lp ) { return (short)AFX_NUM_EVENTPARAMINDEX( short, lp, 0); } // MouseUp, MouseDown
				};
			
			

			/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
			//	CVBFCombo class for the VBFCombo VBX
			//	
			class CVBFCombo : public CComboBox
				{
				public:
				CVBControl* GetVBX() { return (CVBControl*)this; };
				CHsz CtlName() { return CHsz((CVBControl*)this, 0); }
				CLong Left() { return CLong((CVBControl*)this, 2); }
				CLong Top() { return CLong((CVBControl*)this, 3); }
				CLong Width() { return CLong((CVBControl*)this, 4); }
				CLong Height() { return CLong((CVBControl*)this, 5); }
				CBool Visible() { return CBool((CVBControl*)this, 6); }
				CHsz Tag() { return CHsz((CVBControl*)this, 10); }
				CHsz FontName() { return CHsz((CVBControl*)this, 11); }
				CBool FontBold() { return CBool((CVBControl*)this, 12); }
				CFloat FontSize() { return CFloat((CVBControl*)this, 13); }
				CLong ForeColor() { return CLong((CVBControl*)this, 14); }
				CInt TabIndex() { return CInt((CVBControl*)this, 15); }
				CBool TabStop() { return CBool((CVBControl*)this, 16); }
				CBool Enabled() { return CBool((CVBControl*)this, 17); }
				CInt ListCount() { return CInt((CVBControl*)this, 19); } // special
				BOOL ListIndex( int index = 0) { return (BOOL)((CVBControl*)this)->GetNumProperty( 20, index ); } // special
				CString ListString( int index = 0) { return (CString)((CVBControl*)this)->GetStrProperty( 21, index ); } // special
				CBool Border3D() { return CBool((CVBControl*)this, 22); }
				CLong SetSel() { return CLong((CVBControl*)this, 26); }  // special
				CLong InitialValue() { return CLong((CVBControl*)this, 27); }
				CInt ItemHeight() { return CInt((CVBControl*)this, 28); }
				CInt StaticHeight() { return CInt((CVBControl*)this, 29); }
				CInt ListHeight() { return CInt((CVBControl*)this, 30); }
				CInt DataType() { return CInt((CVBControl*)this, 31); }
				CInt FilesDisplay() { return CInt((CVBControl*)this, 32); }
				CBool AutoSearchInList() { return CBool((CVBControl*)this, 33); }
				CInt BackColor() { return CInt((CVBControl*)this, 34); }
				CInt Text3D() { return CInt((CVBControl*)this, 35); }
				CInt TextAlignment() { return CInt((CVBControl*)this, 36); }
				CHsz InValue() { return CHsz((CVBControl*)this, 37); }
				CHsz OutValue() { return CHsz((CVBControl*)this, 38); }
				// Events support 
				short EventSelChangeID( LPVOID lp ) { return (short)AFX_NUM_EVENTPARAMINDEX( short, lp, 0); } 
				LPCSTR EventSelChangeString( LPVOID lp ) { return (LPCSTR)AFX_HLSTR_EVENTPARAMINDEX( lp, 1); } 
				short EventKeyCode( LPVOID lp ) { return (short)AFX_NUM_EVENTPARAMINDEX( short, lp, 1); } // KeyUp, KeyDown
				short EventKeyShift( LPVOID lp ) { return (short)AFX_NUM_EVENTPARAMINDEX( short, lp, 0); } // KeyUp, KeyDown
				short EventKeyPress( LPVOID lp ) { return (short)AFX_NUM_EVENTPARAM( short, lp ); } // KeyPress
				short EventMouseBtn( LPVOID lp ) { return (short)AFX_NUM_EVENTPARAMINDEX( short, lp, 3); } // MouseUp, MouseDown
				short EventMouseShift( LPVOID lp ) { return (short)AFX_NUM_EVENTPARAMINDEX( short, lp, 2); } // MouseUp, MouseDown
				short EventMouseX( LPVOID lp ) { return (short)AFX_NUM_EVENTPARAMINDEX( short, lp, 1); } // MouseUp, MouseDown
				short EventMouseY( LPVOID lp ) { return (short)AFX_NUM_EVENTPARAMINDEX( short, lp, 0); } // MouseUp, MouseDown
				};
				
			
			        
				
			/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
			//	CVBPictBtn class for the VBPicBtn VBX
			//	
			class CVBPicBtn : public CButton
				{
				public:
				CVBControl* GetVBX() { return (CVBControl*)this; };
				CHsz CtlName() { return CHsz((CVBControl*)this, 0); }
				CLong Left() { return CLong((CVBControl*)this, 2); }
				CLong Top() { return CLong((CVBControl*)this, 3); }
				CLong Width() { return CLong((CVBControl*)this, 4); }
				CLong Height() { return CLong((CVBControl*)this, 5); }
				CBool Visible() { return CBool((CVBControl*)this, 6); }
				CHsz Tag() { return CHsz((CVBControl*)this, 10); }
				CInt TabIndex() { return CInt((CVBControl*)this, 11); }
				CBool TabStop() { return CBool((CVBControl*)this, 12); }
				CBool Enabled() { return CBool((CVBControl*)this, 13); }
				CLong CornersColor() { return CLong((CVBControl*)this, 15); }
				CLong BackColor() { return CLong((CVBControl*)this, 16); }
				CBool HandCursor() { return CBool((CVBControl*)this, 17); }
				CBool ShowBorder() { return CBool((CVBControl*)this, 18); }
				CBool ShowFocus() { return CBool((CVBControl*)this, 19); }
				CInt XMargin() { return CInt((CVBControl*)this, 20); }
				CInt YMargin() { return CInt((CVBControl*)this, 21); }
				CInt BitmapWidth() { return CInt((CVBControl*)this, 22); }
				CInt BitmapHeight() { return CInt((CVBControl*)this, 23); }
				CPicture PictureUp() { return CPicture((CVBControl*)this, 24); }
				CPicture PictureDown() { return CPicture((CVBControl*)this, 25); }
				CPicture PictureDisabled() { return CPicture((CVBControl*)this, 26); }
				CPicture PictureFocus() { return CPicture((CVBControl*)this, 27); }
				CInt DisplayMode() { return CInt((CVBControl*)this, 28); }
				CBool UseSystemColors() { return CBool((CVBControl*)this, 29); }
				CBool UseTranspBitmap() { return CBool((CVBControl*)this, 33); }
				CBool OnOffMode() { return CBool((CVBControl*)this, 34); }
				CBool ButtonState() { return CBool((CVBControl*)this, 35); } // special
				CBool AlwaysRepaint() { return CBool((CVBControl*)this, 36); }                                         
				CBool SetState() { return CBool((CVBControl*)this, 37); }// special                                         
				CBool RadioMode() { return CBool((CVBControl*)this, 38); }// special                                         
				// Events support 
				short EventKeyCode( LPVOID lp ) { return (short)AFX_NUM_EVENTPARAMINDEX( short, lp, 1); } // KeyUp, KeyDown
				short EventKeyShift( LPVOID lp ) { return (short)AFX_NUM_EVENTPARAMINDEX( short, lp, 0); } // KeyUp, KeyDown
				short EventMouseBtn( LPVOID lp ) { return (short)AFX_NUM_EVENTPARAMINDEX( short, lp, 3); } // MouseUp, MouseDown
				short EventMouseShift( LPVOID lp ) { return (short)AFX_NUM_EVENTPARAMINDEX( short, lp, 2); } // MouseUp, MouseDown
				short EventMouseX( LPVOID lp ) { return (short)AFX_NUM_EVENTPARAMINDEX( short, lp, 1); } // MouseUp, MouseDown
				short EventMouseY( LPVOID lp ) { return (short)AFX_NUM_EVENTPARAMINDEX( short, lp, 0); } // MouseUp, MouseDown
				};
			    
			    
			/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
			//	CVBGauge class for the VBGauge VBX
			//	
			class CVBGauge : public CStatic
				{
				public:
				CVBControl* GetVBX() { return (CVBControl*)this; };
				CHsz CtlName() { return CHsz((CVBControl*)this, 0); }
				CLong Left() { return CLong((CVBControl*)this, 2); }
				CLong Top() { return CLong((CVBControl*)this, 3); }
				CLong Width() { return CLong((CVBControl*)this, 4); }
				CLong Height() { return CLong((CVBControl*)this, 5); }
				CBool Visible() { return CBool((CVBControl*)this, 6); }
				CHsz Tag() { return CHsz((CVBControl*)this, 10); }
				CInt BorderStyle() { return CInt((CVBControl*)this, 11); }
				CBool TabStop() { return CBool((CVBControl*)this, 12); }
				CBool Enabled() { return CBool((CVBControl*)this, 13); }
				CInt GaugeColor() { return CInt((CVBControl*)this, 16); }
				CInt BackColor() { return CInt((CVBControl*)this, 17); }
				CBool VariableColors() { return CBool((CVBControl*)this, 18); }
				CFloat Minimum() { return CFloat((CVBControl*)this, 19); }
				CFloat Maximum() { return CFloat((CVBControl*)this, 20); }
				CFloat Value() { return CFloat((CVBControl*)this, 21); }
				CBool Gauge3DBorder() { return CBool((CVBControl*)this, 22); }
				CBool Border3D() { return CBool((CVBControl*)this, 26); }
				CBool ShowTheRate() { return CBool((CVBControl*)this, 27); }
				};
			
			
			
										
			/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
			//	CVBTab class for the VBTab VBX
			//	
			class CVBTab : public CButton
				{
				public:
				CVBControl* GetVBX() { return (CVBControl*)this; };
				CHsz CtlName() { return CHsz((CVBControl*)this, 0); }
				CLong Left() { return CLong((CVBControl*)this, 2); }
				CLong Top() { return CLong((CVBControl*)this, 3); }
				CLong Width() { return CLong((CVBControl*)this, 4); }
				CLong Height() { return CLong((CVBControl*)this, 5); }
				CBool Visible() { return CBool((CVBControl*)this, 6); }
				CHsz Tag() { return CHsz((CVBControl*)this, 10); }
				CLong BackColor() { return CLong((CVBControl*)this, 11); }
				CLong FlashColor() { return CLong((CVBControl*)this, 12); }
				CLong FlashTxtColor() { return CLong((CVBControl*)this, 13); }
				CBool Active() { return CBool((CVBControl*)this, 14); } // special
				CBool HandCursor() { return CBool((CVBControl*)this, 15); }
				CInt Text3D() { return CInt((CVBControl*)this, 16); }
				CHsz Caption() { return CHsz((CVBControl*)this, 19); }
				CHsz FontName() { return CHsz((CVBControl*)this, 20); }
				CBool FontBold() { return CBool((CVBControl*)this, 21); }
				CBool FontItalic() { return CBool((CVBControl*)this, 22); }
				CBool FontUnderline() { return CBool((CVBControl*)this, 23); }
				CFloat FontSize() { return CFloat((CVBControl*)this, 24); }
				CLong ForeColor() { return CLong((CVBControl*)this, 25); }
				CBool TabStop() { return CBool((CVBControl*)this, 27); }
				CBool Enabled() { return CBool((CVBControl*)this, 28); }
				CInt MousePointer() { return CInt((CVBControl*)this, 29); }
				CBool UseSystemColors() { return CBool((CVBControl*)this, 32); }
				CBool FirstLine() { return CBool((CVBControl*)this, 33); }
				CBool FirstLeft() { return CBool((CVBControl*)this, 34); }
				CBool FirstRight() { return CBool((CVBControl*)this, 35); }
				CBool TabCorners() { return CBool((CVBControl*)this, 36); }
				// Events support 
				short EventKeyCode( LPVOID lp ) { return (short)AFX_NUM_EVENTPARAMINDEX( short, lp, 1); } // KeyUp, KeyDown
				short EventKeyShift( LPVOID lp ) { return (short)AFX_NUM_EVENTPARAMINDEX( short, lp, 0); } // KeyUp, KeyDown
				short EventKeyPress( LPVOID lp ) { return (short)AFX_NUM_EVENTPARAM( short, lp ); } // KeyPress
				short EventMouseBtn( LPVOID lp ) { return (short)AFX_NUM_EVENTPARAMINDEX( short, lp, 3); } // MouseUp, MouseDown
				short EventMouseShift( LPVOID lp ) { return (short)AFX_NUM_EVENTPARAMINDEX( short, lp, 2); } // MouseUp, MouseDown
				short EventMouseX( LPVOID lp ) { return (short)AFX_NUM_EVENTPARAMINDEX( short, lp, 1); } // MouseUp, MouseDown
				short EventMouseY( LPVOID lp ) { return (short)AFX_NUM_EVENTPARAMINDEX( short, lp, 0); } // MouseUp, MouseDown
				};
				
			
			/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
			//	CVBText class for the VBText VBX
			//	
			class CVBText : public CStatic
				{
				public:
				CVBControl* GetVBX() { return (CVBControl*)this; };
				CHsz CtlName() { return CHsz((CVBControl*)this, 0); }
				CLong Left() { return CLong((CVBControl*)this, 2); }
				CLong Top() { return CLong((CVBControl*)this, 3); }
				CLong Width() { return CLong((CVBControl*)this, 4); }
				CLong Height() { return CLong((CVBControl*)this, 5); }
				CBool Visible() { return CBool((CVBControl*)this, 6); }
				CHsz Tag() { return CHsz((CVBControl*)this, 10); }
				CInt BackColor() { return CInt((CVBControl*)this, 11); }
				CInt Style3D() { return CInt((CVBControl*)this, 12); }
				CInt VerticalAlignment() { return CInt((CVBControl*)this, 13); }
				CInt HorizAlignment() { return CInt((CVBControl*)this, 14); }
				CBool Multiline() { return CBool((CVBControl*)this, 15); }
				CBool Autosizing() { return CBool((CVBControl*)this, 16); }
				CHsz Caption() { return CHsz((CVBControl*)this, 20); }
				CHsz FontName() { return CHsz((CVBControl*)this, 21); }
				CBool FontBold() { return CBool((CVBControl*)this, 22); }
				CBool FontItalic() { return CBool((CVBControl*)this, 23); }
				CBool FontUnderline() { return CBool((CVBControl*)this, 24); }
				CFloat FontSize() { return CFloat((CVBControl*)this, 25); }
				CLong ForeColor() { return CLong((CVBControl*)this, 26); }
				CBool TabStop() { return CBool((CVBControl*)this, 28); }
				CBool Enabled() { return CBool((CVBControl*)this, 29); }
				CInt MousePointer() { return CInt((CVBControl*)this, 30); }
				CInt Frame3D() { return CInt((CVBControl*)this, 32); }
				// Events support 
				short EventKeyCode( LPVOID lp ) { return (short)AFX_NUM_EVENTPARAMINDEX( short, lp, 1); } // KeyUp, KeyDown
				short EventKeyShift( LPVOID lp ) { return (short)AFX_NUM_EVENTPARAMINDEX( short, lp, 0); } // KeyUp, KeyDown
				short EventMouseBtn( LPVOID lp ) { return (short)AFX_NUM_EVENTPARAMINDEX( short, lp, 3); } // MouseUp, MouseDown
				short EventMouseShift( LPVOID lp ) { return (short)AFX_NUM_EVENTPARAMINDEX( short, lp, 2); } // MouseUp, MouseDown
				short EventMouseX( LPVOID lp ) { return (short)AFX_NUM_EVENTPARAMINDEX( short, lp, 1); } // MouseUp, MouseDown
				short EventMouseY( LPVOID lp ) { return (short)AFX_NUM_EVENTPARAMINDEX( short, lp, 0); } // MouseUp, MouseDown
				};
			
			
			
			/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
			//	CVBAnim class for the VBAnim VBX
			//	
			class CVBAnim : public CStatic
				{
				public:
				CVBControl* GetVBX() { return (CVBControl*)this; };
				CHsz CtlName() { return CHsz((CVBControl*)this, 0); }
				CLong Left() { return CLong((CVBControl*)this, 2); }
				CLong Top() { return CLong((CVBControl*)this, 3); }
				CLong Width() { return CLong((CVBControl*)this, 4); }
				CLong Height() { return CLong((CVBControl*)this, 5); }
				CBool Visible() { return CBool((CVBControl*)this, 6); }
				CHsz Tag() { return CHsz((CVBControl*)this, 10); }
				CInt DisplayMode() { return CInt((CVBControl*)this, 11); }
				CInt XMargin() { return CInt((CVBControl*)this, 12); }
				CInt YMargin() { return CInt((CVBControl*)this, 13); }
				CInt PictureWidth() { return CInt((CVBControl*)this, 14); }
				CInt PictureHeight() { return CInt((CVBControl*)this, 15); }
				CPicture Picture1() { return CPicture((CVBControl*)this, 16); }
				CPicture Picture2() { return CPicture((CVBControl*)this, 17); }
				CPicture Picture3() { return CPicture((CVBControl*)this, 18); }
				CPicture Picture4() { return CPicture((CVBControl*)this, 19); }
				CPicture Picture5() { return CPicture((CVBControl*)this, 20); }
				CInt BackColor() { return CInt((CVBControl*)this, 21); }
				CInt Speed() { return CInt((CVBControl*)this, 22); }
				CInt ProcessMode() { return CInt((CVBControl*)this, 23); }
				CBool Border3D() { return CBool((CVBControl*)this, 24); }
				CInt TabIndex() { return CInt((CVBControl*)this, 28); }
				CBool TabStop() { return CBool((CVBControl*)this, 29); }
				CBool Enabled() { return CBool((CVBControl*)this, 30); }
				CInt MousePointer() { return CInt((CVBControl*)this, 31); }
				CBool AlwaysRepaint() { return CBool((CVBControl*)this, 33); }
				CBool UseTransparentBitmap() { return CBool((CVBControl*)this, 34); }
				// Events support 
				short EventKeyCode( LPVOID lp ) { return (short)AFX_NUM_EVENTPARAMINDEX( short, lp, 1); } // KeyUp, KeyDown
				short EventKeyShift( LPVOID lp ) { return (short)AFX_NUM_EVENTPARAMINDEX( short, lp, 0); } // KeyUp, KeyDown
				short EventMouseBtn( LPVOID lp ) { return (short)AFX_NUM_EVENTPARAMINDEX( short, lp, 3); } // MouseUp, MouseDown
				short EventMouseShift( LPVOID lp ) { return (short)AFX_NUM_EVENTPARAMINDEX( short, lp, 2); } // MouseUp, MouseDown
				short EventMouseX( LPVOID lp ) { return (short)AFX_NUM_EVENTPARAMINDEX( short, lp, 1); } // MouseUp, MouseDown
				short EventMouseY( LPVOID lp ) { return (short)AFX_NUM_EVENTPARAMINDEX( short, lp, 0); } // MouseUp, MouseDown
				};
				
			
			
				
			/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
			//	CVBLine class for the VBLine VBX
			//	
			class CVBLine : public CStatic
				{
				public:
				CVBControl* GetVBX() { return (CVBControl*)this; };
				CHsz CtlName() { return CHsz((CVBControl*)this, 0); }
				CLong Left() { return CLong((CVBControl*)this, 2); }
				CLong Top() { return CLong((CVBControl*)this, 3); }
				CLong Width() { return CLong((CVBControl*)this, 4); }
				CLong Height() { return CLong((CVBControl*)this, 5); }
				CBool Visible() { return CBool((CVBControl*)this, 6); }
				CHsz Tag() { return CHsz((CVBControl*)this, 10); }
				CInt LineStyle() { return CInt((CVBControl*)this, 11); }
				CInt Style3D() { return CInt((CVBControl*)this, 12); }
				CInt BackColor() { return CInt((CVBControl*)this, 13); }
				CInt LineColor() { return CInt((CVBControl*)this, 14); }
				CInt LineThickness() { return CInt((CVBControl*)this, 15); }
				CBool TabStop() { return CBool((CVBControl*)this, 20); }
				CInt MousePointer() { return CInt((CVBControl*)this, 22); }
				// Events support 
				short EventMouseBtn( LPVOID lp ) { return (short)AFX_NUM_EVENTPARAMINDEX( short, lp, 3); } // MouseUp, MouseDown
				short EventMouseShift( LPVOID lp ) { return (short)AFX_NUM_EVENTPARAMINDEX( short, lp, 2); } // MouseUp, MouseDown
				short EventMouseX( LPVOID lp ) { return (short)AFX_NUM_EVENTPARAMINDEX( short, lp, 1); } // MouseUp, MouseDown
				short EventMouseY( LPVOID lp ) { return (short)AFX_NUM_EVENTPARAMINDEX( short, lp, 0); } // MouseUp, MouseDown
				};
				

			/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
			//	CVBDDrop class for the VBDDrop VBX
			//	
			class CVBDDrop : public CStatic
				{
				public:
				CVBControl* GetVBX() { return (CVBControl*)this; };
				CHsz CtlName() { return CHsz((CVBControl*)this, 0); }
				CLong Left() { return CLong((CVBControl*)this, 2); }
				CLong Top() { return CLong((CVBControl*)this, 3); }
				CLong Width() { return CLong((CVBControl*)this, 4); }
				CLong Height() { return CLong((CVBControl*)this, 5); }
				CBool TabStop() { return CBool((CVBControl*)this, 7); }
				CInt DroppedFiles() { return CInt((CVBControl*)this, 12); } // special
				CString Filename( int index = 0) { return ((CVBControl*)this)->GetStrProperty( 13, index ); } // special
				CLong BackColor() { return CLong((CVBControl*)this, 14); }
				CBool Visible() { return CBool((CVBControl*)this, 15); }
				// Event support
				short EventDroppedFiles( LPVOID lp ) { return (short)AFX_NUM_EVENTPARAM( short, lp ); } // Number of dropped files				
				};
			
			
			
			/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
			//	CVBNote class for the VBNote VBX
			//	
			class CVBNote : public CStatic
				{
				public:
				CVBControl* GetVBX() { return (CVBControl*)this; };
				CHsz CtlName() { return CHsz((CVBControl*)this, 0); }
				CLong Left() { return CLong((CVBControl*)this, 2); }
				CLong Top() { return CLong((CVBControl*)this, 3); }
				CLong Width() { return CLong((CVBControl*)this, 4); }
				CLong Height() { return CLong((CVBControl*)this, 5); }
				CHsz Caption() { return CHsz((CVBControl*)this, 7); }
				CHsz FontName() { return CHsz((CVBControl*)this, 8); }
				CBool FontBold() { return CBool((CVBControl*)this, 9); }
				CBool FontItalic() { return CBool((CVBControl*)this, 10); }
				CFloat FontSize() { return CFloat((CVBControl*)this, 11); }
				CLong ForeColor() { return CLong((CVBControl*)this, 12); }
				CLong BackColor() { return CLong((CVBControl*)this, 13); }
				CBool TabStop() { return CBool((CVBControl*)this, 14); }
				};
			
			
			
			/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
			//	CVB3D class for the VB3D VBX
			//	
			class CVB3D : public CStatic
				{
				public:
				CVBControl* GetVBX() { return (CVBControl*)this; };
				CHsz CtlName() { return CHsz((CVBControl*)this, 0); }
				CLong Left() { return CLong((CVBControl*)this, 2); }
				CLong Top() { return CLong((CVBControl*)this, 3); }
				CLong Width() { return CLong((CVBControl*)this, 4); }
				CLong Height() { return CLong((CVBControl*)this, 5); }
				CBool TabStop() { return CBool((CVBControl*)this, 7); }
				CHsz Tag() { return CHsz((CVBControl*)this, 9); }
				CBool UseSystemColors() { return CBool((CVBControl*)this, 13); }
				CInt Mode3D() { return CInt((CVBControl*)this, 14); }
				};
												



/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//	PART 3 - DDXs
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#ifdef _CSTR
#pragma message("VBXSTD12.H: Including VBX Studio DDX routines...")
#ifdef _AFXDLL
#error _AFXDLL not available with String Studio 1.2...
#endif

			// ----------------------------------------------------------------------------------------------------------
			//	To use these DDX, don' t forget to call UpdateData( TRUE )
			//	before using the CTime object.
			//	String Studio time functions requires the century specification ( ToTime ), so
			//	we make some little changes..
			// ----------------------------------------------------------------------------------------------------------
			#define USCTime   			CTime   // same as CTime but easier to read in the Classwizard
			#define USLCTime           CTime                                                                                         
			#define FRCTime				 CTime
			#define FRLCTime            CTime
			
			_inline void AFXAPI DDX_CTimeUS( CDataExchange* pDX, int nIDC, int nPropIndex, CTime& value )
				{                                                                                                                                           
				CStr szTemp, szTemp2;
				if ( pDX->m_bSaveAndValidate ) // Dialog to variable
					{
					pDX->m_pDlgWnd->GetDlgItemText( nIDC, szTemp.GetBuffer(14), 9 );
					szTemp.ReleaseBuffer();
					if ( szTemp.GetLength() == 8 )
						{
						szTemp2 = szTemp;
						szTemp2 = szTemp2.Left( 6 );
						szTemp2 += "19";		// always 19...
						szTemp2 += szTemp.Right( 2 );
						value = szTemp2.ToTime();
						}
					else
						value = 0;
					}
				else // variable to Dialog
					{
					if ( value != 0 )
						{
						szTemp.From( value );
						pDX->m_pDlgWnd->SetDlgItemText( nIDC, szTemp );
						}
					}
				}
			
			_inline void AFXAPI DDX_CTimeUSLong( CDataExchange* pDX, int nIDC, int nPropIndex, CTime& value )
				{                                                                                                                                           
				CStr szTemp, szTemp2;
				if ( pDX->m_bSaveAndValidate ) // Dialog to variable
					{
					pDX->m_pDlgWnd->GetDlgItemText( nIDC, szTemp.GetBuffer(14), 11 );
					szTemp.ReleaseBuffer();
					value = szTemp.ToTime();
					}
				else // variable to Dialog
					{
					if ( value != 0 )
						{
						szTemp.From( value, "%m/%d/%Y" );
						pDX->m_pDlgWnd->SetDlgItemText( nIDC, szTemp );
						}
					}
				}
			
			_inline void AFXAPI DDX_CTimeFrench( CDataExchange* pDX, int nIDC, int nPropIndex, CTime& value )
				{                                                                                                                                           
				CStr szTemp, szTemp2;
				if ( pDX->m_bSaveAndValidate ) // Dialog to variable
					{
					pDX->m_pDlgWnd->GetDlgItemText( nIDC, szTemp.GetBuffer(14), 9 );
					szTemp.ReleaseBuffer();
					if ( szTemp.GetLength() == 8 )
						{
						szTemp2 = szTemp;
						szTemp2 = szTemp2.Left( 6 );
						szTemp2 += "19";		// always 19...
						szTemp2 += szTemp.Right( 2 );
						value = szTemp2.ToTime("D/M/Y");
						}
					else
						value = 0;
					}
				else // variable to Dialog
					{
					if ( value != 0 )
						{
						szTemp.From( value, "%d/%m/%y" );
						pDX->m_pDlgWnd->SetDlgItemText( nIDC, szTemp );
						}
					}
				}
			
			_inline void AFXAPI DDX_CTimeFrenchLong( CDataExchange* pDX, int nIDC, int nPropIndex, CTime& value )
				{                                                                                                                                           
				CStr szTemp, szTemp2;
				if ( pDX->m_bSaveAndValidate ) // Dialog to variable
					{
					pDX->m_pDlgWnd->GetDlgItemText( nIDC, szTemp.GetBuffer(14), 11 );
					szTemp.ReleaseBuffer();
					value = szTemp.ToTime("D/M/Y");
					}
				else // variable to Dialog
					{
					if ( value != 0 )
						{
						szTemp.From( value, "%d/%m/%Y" );
						pDX->m_pDlgWnd->SetDlgItemText( nIDC, szTemp );
						}
					}
				}
			
			_inline void AFXAPI DDX_VBCStrText(CDataExchange* pDX, int nIDC, int nPropIndex, CStr& value )
				{ DDX_VBText( pDX, nIDC, nPropIndex, (CString&) value); }
			_inline void AFXAPI DDX_CStrText(CDataExchange* pDX, int nIDC, CStr& value )
				{ DDX_Text( pDX, nIDC, (CString&) value); }
			
			
#else
#pragma message("VBXSTD12.H: String Studio not found, no CTime, CStr DDXs...")
#endif
			
			_inline void AFXAPI DDX_VBEdit(CDataExchange* pDX, int nIDC, CVBEdit*& rpControl)
				{	DDX_VBControl( pDX, nIDC, (CVBControl*&) rpControl);	}
			_inline void AFXAPI DDX_VBList(CDataExchange* pDX, int nIDC, CVBList*& rpControl)
				{	DDX_VBControl( pDX, nIDC, (CVBControl*&) rpControl);	}
			_inline void AFXAPI DDX_VBFList(CDataExchange* pDX, int nIDC, CVBFList*& rpControl)
				{	DDX_VBControl( pDX, nIDC, (CVBControl*&) rpControl);	}
			_inline void AFXAPI DDX_VBCombo(CDataExchange* pDX, int nIDC, CVBCombo*& rpControl)
				{	DDX_VBControl( pDX, nIDC, (CVBControl*&) rpControl);	}
			_inline void AFXAPI DDX_VBFCombo(CDataExchange* pDX, int nIDC, CVBFCombo*& rpControl)
				{	DDX_VBControl( pDX, nIDC, (CVBControl*&) rpControl);	}
			_inline void AFXAPI DDX_VBSpin(CDataExchange* pDX, int nIDC, CVBSpin*& rpControl)
				{	DDX_VBControl( pDX, nIDC, (CVBControl*&) rpControl);	}
			_inline void AFXAPI DDX_VBTab(CDataExchange* pDX, int nIDC, CVBTab*& rpControl)
				{	DDX_VBControl( pDX, nIDC, (CVBControl*&) rpControl);	}
			_inline void AFXAPI DDX_VBCText(CDataExchange* pDX, int nIDC, CVBText*& rpControl)
				{	DDX_VBControl( pDX, nIDC, (CVBControl*&) rpControl);	}
			_inline void AFXAPI DDX_VBAnim(CDataExchange* pDX, int nIDC, CVBAnim*& rpControl)
				{	DDX_VBControl( pDX, nIDC, (CVBControl*&) rpControl);	}
			_inline void AFXAPI DDX_VBPicBtn(CDataExchange* pDX, int nIDC, CVBPicBtn*& rpControl)
				{	DDX_VBControl( pDX, nIDC, (CVBControl*&) rpControl);	}
			_inline void AFXAPI DDX_VBDDrop(CDataExchange* pDX, int nIDC, CVBDDrop*& rpControl)
				{	DDX_VBControl( pDX, nIDC, (CVBControl*&) rpControl);	}
			_inline void AFXAPI DDX_VBLine(CDataExchange* pDX, int nIDC, CVBLine*& rpControl)
				{	DDX_VBControl( pDX, nIDC, (CVBControl*&) rpControl);	}
			_inline void AFXAPI DDX_VB3D(CDataExchange* pDX, int nIDC, CVB3D*& rpControl)
				{	DDX_VBControl( pDX, nIDC, (CVBControl*&) rpControl);	}
			_inline void AFXAPI DDX_VBNote(CDataExchange* pDX, int nIDC, CVBNote*& rpControl)
				{	DDX_VBControl( pDX, nIDC, (CVBControl*&) rpControl);	}
			_inline void AFXAPI DDX_VBGauge(CDataExchange* pDX, int nIDC, CVBGauge*& rpControl)
				{	DDX_VBControl( pDX, nIDC, (CVBControl*&) rpControl);	}
			
  
  
